## flann 1.6.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

project(flann)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

include(${PROJECT_SOURCE_DIR}/cmake/flann_utils.cmake)
set(FLANN_VERSION 1.6.11)
DISSECT_VERSION()
GET_OS_INFO()

# Add an "uninstall" target
CONFIGURE_FILE ("${PROJECT_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET (uninstall "${CMAKE_COMMAND}" -P
    "${PROJECT_BINARY_DIR}/uninstall_target.cmake")

# Set the build type.  Options are:
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries

if (NOT CMAKE_BUILD_TYPE)
    #set(CMAKE_BUILD_TYPE Release)
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Build type" FORCE)
    #set(CMAKE_BUILD_TYPE Debug)
endif()

#set the default path for built executables to the "bin" directory
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
#set the default path for built libraries to the "lib" directory
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)
# set output path for tests
set(TEST_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/test)

option(BUILD_C_BINDINGS "Build C bindings" ON)
option(BUILD_PYTHON_BINDINGS "Build Python bindings" ON)
option(BUILD_MATLAB_BINDINGS "Build Matlab bindings" ON)
option(USE_MPI "Use MPI" OFF)


if (NOT BUILD_C_BINDINGS)
    set(BUILD_PYTHON_BINDINGS OFF)
    set(BUILD_MATLAB_BINDINGS OFF)
endif()


# find python
find_package(PythonInterp)
if (NOT PYTHON_EXECUTABLE)
    set(BUILD_PYTHON_BINDINGS OFF)
endif()

find_hdf5()
if (NOT HDF5_FOUND)
	message(WARNING "hdf5 library not found, some tests will not be run")
endif()

if (USE_MPI OR HDF5_IS_PARALLEL)
    find_package(MPI)
endif()
if (HDF5_IS_PARALLEL)
    if (NOT MPI_FOUND)
        message(WARNING "Found the parallel HDF5 library, but could not find the MPI library. Define the MPI_COMPILER variable to the path of your MPI compiler.")
    endif()
    # Parallel HDF5 needs to find the "mpi.h" header file
    include_directories(${MPI_INCLUDE_PATH})
endif()


if (USE_MPI)
    if (NOT MPI_FOUND)
        message(WARNING "Could not find an MPI library. Define the MPI_COMPILER variable to the path of your MPI compiler.")
    endif()

    if (NOT HDF5_IS_PARALLEL)
        message(WARNING "For MPI support the Parallel HDF5 library is required.")
    endif()

endif(USE_MPI)

find_package(GTest) 
if (NOT GTEST_FOUND)
	message(WARNING "gtest library not found, some tests will not be run")
endif()


#set the C/C++ include path to the "include" directory
include_directories(${PROJECT_SOURCE_DIR}/src/cpp)

# require proper c++
#add_definitions( "-Wall -ansi -pedantic" )
# HDF5 uses long long which is not ansi
if (WIN32)
    # lots of warnings with cl.exe right now
    # TODO: fix this
    add_definitions( "-w" )
else(WIN32)
    add_definitions( "-Wall" )
endif(WIN32)

add_subdirectory( cmake )
add_subdirectory( src )
add_subdirectory( examples )
add_subdirectory( test )
add_subdirectory( doc )


# CPACK options

# RPM
find_program(RPM_PROGRAM rpm)
if(EXISTS ${RPM_PROGRAM})
  list(APPEND CPACK_GENERATOR "RPM")
endif(EXISTS ${RPM_PROGRAM})
# DEB
find_program(DPKG_PROGRAM dpkg)
if(EXISTS ${DPKG_PROGRAM})
  list(APPEND CPACK_GENERATOR "DEB")
endif(EXISTS ${DPKG_PROGRAM})
# NSIS
find_program(NSIS_PROGRAM makensis MakeNSIS)
if(EXISTS ${NSIS_PROGRAM})
  list(APPEND CPACK_GENERATOR "NSIS")
endif(EXISTS ${NSIS_PROGRAM})
# dpkg
find_program(PACKAGE_MAKER_PROGRAM PackageMaker
	    HINTS /Developer/Applications/Utilities)
if(EXISTS ${PACKAGE_MAKER_PROGRAM})
  list(APPEND CPACK_GENERATOR "PackageMaker")
endif(EXISTS ${PACKAGE_MAKER_PROGRAM})
 
set(CPACK_GENERATOR "${CPACK_GENERATOR}")
set(CPACK_MONOLITHIC_INSTALL 1)
set(CPACK_SET_DESTDIR ON)
include(InstallRequiredSystemLibraries)
set(CPACK_PACKAGE_CONTACT "Marius Muja")
set(CPACK_PACKAGING_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
SET(CPACK_PACKAGE_VERSION ${FLANN_VERSION})
SET(CPACK_PACKAGE_VERSION_MAJOR ${FLANN_VERSION_MAJOR})
SET(CPACK_PACKAGE_VERSION_MINOR ${FLANN_VERSION_MINOR})
SET(CPACK_PACKAGE_VERSION_PATCH ${FLANN_VERSION_PATCH})
include(CPack)


message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Building C bindings: ${BUILD_C_BINDINGS}")
message(STATUS "Building python bindings: ${BUILD_PYTHON_BINDINGS}")
message(STATUS "Building matlab bindings: ${BUILD_MATLAB_BINDINGS}")
message(STATUS "Using MPI support: ${USE_MPI}")

=== examples/CMakeLists.txt ===
add_custom_target(examples ALL)


if (BUILD_C_BINDINGS)
    add_executable(flann_example_c flann_example.c)
    target_link_libraries(flann_example_c flann)
    set_target_properties(flann_example_c PROPERTIES COMPILE_FLAGS -std=c99)

    add_dependencies(examples flann_example_c)
    install (TARGETS flann_example_c DESTINATION bin )
endif()

if (HDF5_FOUND)
    include_directories(${HDF5_INCLUDE_DIR})

    add_executable(flann_example_cpp flann_example.cpp)
    target_link_libraries(flann_example_cpp flann_cpp ${HDF5_LIBRARIES})
    if (HDF5_IS_PARALLEL)
        target_link_libraries(flann_example_cpp ${MPI_LIBRARIES})
    endif()

    add_dependencies(examples flann_example_cpp)
    install (TARGETS flann_example_cpp DESTINATION bin)


    if (USE_MPI AND HDF5_IS_PARALLEL)
        add_executable(flann_example_mpi flann_example_mpi.cpp)
        target_link_libraries(flann_example_mpi flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES})

        add_dependencies(examples flann_example_mpi)
        install (TARGETS flann_example_mpi DESTINATION bin)
    endif()
else()
    message("hdf5 library not found, not compiling flann_example.cpp")
endif()

=== test/CMakeLists.txt ===

add_custom_target(tests)
add_custom_target(test)
add_dependencies(test tests)

set(EXECUTABLE_OUTPUT_PATH ${TEST_OUTPUT_PATH})

#add_executable(flann_mt_test flann_mt_test.cpp)
#find_package(Boost COMPONENTS system thread REQUIRED)
#target_link_libraries(flann_mt_test ${Boost_SYSTEM_LIBRARY} ${Boost_THREAD_LIBRARY} flann)

if (PYTHON_EXECUTABLE) 
    flann_download_test_data(sift10K.h5 0964a910946d2dd5fe28337507a8abc3)
    flann_download_test_data(sift10K_byte.h5 f835e0148df4618a81f67febfda2b4d0)
    flann_download_test_data(sift100K.h5 ae2b08f93f3d9f89f5d68566b0406102)
    flann_download_test_data(sift100K_byte.h5 b772255fd2044e9d2a5a0183953e4705)
    flann_download_test_data(cloud.h5 b9f7030c844774baa264c3644129d9c3)
    flann_download_test_data(brief100K.h5 e1e781c0955917bc2f0a27b6344c2342)
endif()

if (GTEST_FOUND AND HDF5_FOUND)
    include_directories(${HDF5_INCLUDE_DIR})
	flann_add_gtest(flann_simple_test flann_simple_test.cpp)
	    target_link_libraries(flann_simple_test flann_cpp ${HDF5_LIBRARIES})
    if (HDF5_IS_PARALLEL)
	    target_link_libraries(flann_simple_test ${MPI_LIBRARIES})
    endif()
endif()

#---------- pyunit tests --------------
if (PYTHON_EXECUTABLE) 
    flann_add_pyunit(test_nn.py)
    flann_add_pyunit(test_nn_index.py)
    flann_add_pyunit(test_index_save.py)
    flann_add_pyunit(test_nn_autotune.py)
    flann_add_pyunit(test_clustering.py)
endif()

=== src/cpp/CMakeLists.txt ===
#include_directories(${CMAKE_SOURCE_DIR}/include algorithms util nn .)

add_definitions(-D_FLANN_VERSION=${FLANN_VERSION})

file(GLOB_RECURSE C_SOURCES *.cpp)
file(GLOB_RECURSE CPP_SOURCES *.cpp)

file(GLOB_RECURSE C_FLANN flann.cpp)
file(GLOB_RECURSE CPP_FLANN flann_cpp.cpp)

list(REMOVE_ITEM CPP_SOURCES ${C_FLANN})
list(REMOVE_ITEM C_SOURCES ${CPP_FLANN})

add_library(flann_cpp_s STATIC ${CPP_SOURCES})
if(CMAKE_COMPILER_IS_GNUCC)
    set_target_properties(flann_cpp_s PROPERTIES COMPILE_FLAGS -fPIC)
endif()
set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
    add_library(flann_cpp SHARED "")
    set_target_properties(flann_cpp PROPERTIES LINKER_LANGUAGE CXX)
    target_link_libraries(flann_cpp -Wl,-whole-archive flann_cpp_s -Wl,-no-whole-archive)
else()
    add_library(flann_cpp SHARED ${CPP_SOURCES})
endif()

set_target_properties(flann_cpp PROPERTIES
   VERSION ${FLANN_VERSION}
   SOVERSION ${FLANN_SOVERSION}
   DEFINE_SYMBOL FLANN_EXPORTS
) 


#debug libraries
add_library(flann_cpp-gd SHARED ${CPP_SOURCES})
set_target_properties(flann_cpp-gd PROPERTIES 
    COMPILE_FLAGS ${CMAKE_CXX_FLAGS_DEBUG}
    DEFINE_SYMBOL FLANN_EXPORTS
)

add_library(flann_cpp_s-gd STATIC ${CPP_SOURCES})
set_target_properties(flann_cpp_s-gd PROPERTIES COMPILE_FLAGS ${CMAKE_CXX_FLAGS_DEBUG})
set_property(TARGET flann_cpp_s-gd PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)

if (BUILD_C_BINDINGS)
    add_library(flann_s STATIC ${C_SOURCES})
    if(CMAKE_COMPILER_IS_GNUCC)
        set_target_properties(flann_s PROPERTIES COMPILE_FLAGS -fPIC)
    endif()
    set_property(TARGET flann_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)

    if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
        add_library(flann SHARED "")
        set_target_properties(flann PROPERTIES LINKER_LANGUAGE CXX)
        target_link_libraries(flann -Wl,-whole-archive flann_s -Wl,-no-whole-archive)
    else()
        add_library(flann SHARED ${C_SOURCES})
    endif()

    set_target_properties(flann PROPERTIES
       VERSION ${FLANN_VERSION}
       SOVERSION ${FLANN_SOVERSION}
       DEFINE_SYMBOL FLANN_EXPORTS
    ) 
endif()


if(WIN32)
if (BUILD_C_BINDINGS)
    install (
        TARGETS flann
        RUNTIME DESTINATION share/flann/matlab
    )
endif()
endif(WIN32)


install (
    TARGETS flann_cpp flann_cpp_s flann_cpp-gd flann_cpp_s-gd
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
)

if (BUILD_C_BINDINGS)
    install (
        TARGETS flann flann_s
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
    )
endif()

install (
    DIRECTORY flann
    DESTINATION include
    FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

=== src/matlab/CMakeLists.txt ===
#IF(WIN32)
#    SET(MEXEXT_CMD cmd /C mexext)
#ELSE(WIN32)
#    SET(MEXEXT_CMD mexext)
#ENDIF(WIN32)

SET(MEX_NAME nearest_neighbors)

if(WIN32)
    find_program(MEX_CMD mex.bat)
    find_program(MEXEXT_CMD mexext.bat)
else()
    find_program(MEX_CMD mex)
    find_program(MEXEXT_CMD mexext)
endif()

find_program(OCT_CMD mkoctfile)

if(MEX_CMD AND MEXEXT_CMD)

    get_filename_component(MEX_REAL_CMD ${MEX_CMD} ABSOLUTE)
    get_filename_component(MEX_PATH ${MEX_REAL_CMD} PATH)

    get_filename_component(MEXEXT_REAL_CMD ${MEXEXT_CMD} ABSOLUTE)
    get_filename_component(MEXEXT_PATH ${MEXEXT_REAL_CMD} PATH)

    if (MEX_PATH STREQUAL MEXEXT_PATH)
        message(STATUS "Found MATLAB at: " ${MEX_PATH})

        EXECUTE_PROCESS(COMMAND ${MEXEXT_REAL_CMD} OUTPUT_VARIABLE MEX_EXTENSION OUTPUT_STRIP_TRAILING_WHITESPACE)
        SET(MEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MEX_NAME}.${MEX_EXTENSION})

        ADD_CUSTOM_COMMAND(
            OUTPUT ${MEX_FILE}
            COMMAND ${MEX_REAL_CMD}
            ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp -I${PROJECT_SOURCE_DIR}/src/cpp -L${LIBRARY_OUTPUT_PATH} -lflann_s
            DEPENDS flann_s ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp
            COMMENT "Building MEX extension ${MEX_FILE}"
        )

        ADD_CUSTOM_TARGET(mex_${MEX_NAME} ALL DEPENDS ${MEX_FILE})

        FILE(GLOB MATLAB_SOURCES *.m)

        INSTALL (
            FILES ${MEX_FILE} ${MATLAB_SOURCES}
            DESTINATION share/flann/matlab
        )
    else()
        message(SEND_ERROR "The 'mex' and 'mexext' programs have been found in different locations. It's likely that one of them is not part of the MATLAB instalation. Make sure that the 'bin' directory from the MATLAB instalation is in PATH")
    endif()
elseif(OCT_CMD)
  SET(MEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MEX_NAME}.mex)
  ADD_CUSTOM_COMMAND(
    OUTPUT ${MEX_FILE}
    COMMAND ${OCT_CMD}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp -I${PROJECT_SOURCE_DIR}/src/cpp -L${LIBRARY_OUTPUT_PATH} -DFLANN_STATIC -lflann_s --mex
    DEPENDS flann_s ${CMAKE_CURRENT_SOURCE_DIR}/${MEX_NAME}.cpp
    COMMENT "Building MEX extension ${MEX_FILE}"
    )

  ADD_CUSTOM_TARGET(mex_${MEX_NAME} ALL DEPENDS ${MEX_FILE})

  FILE(GLOB MATLAB_SOURCES *.m)

  INSTALL (
    FILES ${MEX_FILE} ${MATLAB_SOURCES}
    DESTINATION share/flann/octave
    )
else()
    message(SEND_ERROR "Cannot find MATLAB or Octave instalation. Make sure that the 'bin' directory from the MATLAB instalation or that mkoctfile is in PATH")
endif()

=== debian/changelog ===
flann (1.6.11-1) unstable; urgency=low

  * Initial release (Closes: #581903)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 23 Aug 2011 16:55:38 +0200

=== debian/control ===
Source: flann
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>,
 Michael Kleiber <mike@kleibi.de>
Build-Depends: debhelper (>= 7.0.50~), cmake, quilt (>= 0.46-7~),
 libgtest-dev, python, python-numpy, texlive-binaries, libboost1.46-dev,
 texlive-latex-base, latex2html, mpi-default-dev, libhdf5-mpi-dev [!hurd-i386]
Standards-Version: 3.9.2
Homepage: http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/flann/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/flann/trunk/

Package: libflann-dev
Section: libdevel
Architecture: any
Depends: libflann1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Fast Library for Approximate Nearest Neighbors - development
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms we found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains development files needed to build FLANN applications.

Package: libflann1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Fast Library for Approximate Nearest Neighbors - runtime
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms we found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the libraries needed to run FLANN applications.

Package: flann-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Fast Library for Approximate Nearest Neighbors - documentation
 FLANN is a library for performing fast approximate nearest neighbor searches
 in high dimensional spaces. It contains a collection of algorithms we found
 to work best for nearest neighbor search and a system for automatically
 choosing the best algorithm and optimum parameters depending on the dataset.
 .
 This package contains the documentation for FLANN.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

%:
	dh --parallel --with quilt --buildsystem=cmake $@ 

override_dh_auto_configure:
	# cant get mpi to work for now: https://github.com/mariusmuja/flann/issues/10
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DCMAKE_SKIP_RPATH:BOOL=ON -DBUILD_MATLAB_BINDINGS:BOOL=OFF -DBUILD_PYTHON_BINDINGS:BOOL=OFF -DUSE_MPI:BOOL=OFF

override_dh_auto_test:
	# test download material from the net. Removing them.

override_dh_compress:
	dh_compress --exclude=.pdf

VER_MAJOR = 1
VER_MINOR = 6
VER_PATCH = 11
VER_FULL = $(VER_MAJOR).$(VER_MINOR).$(VER_PATCH)

UPSTREAM_SRC = flann-$(VER_FULL)-src
DEBIAN_SRC_DIR = flann-$(VER_FULL)
DEBIAN_SRC_TAR = flann_$(VER_FULL).orig.tar.gz

$(UPSTREAM_SRC).zip:
	#uscan --verbose --force-download --repack --rename
	wget -c http://people.cs.ubc.ca/~mariusm/uploads/FLANN/$@

get-orig-source: $(UPSTREAM_SRC).zip
	rm -rf $(DEBIAN_SRC_DIR)
	unzip -q $(UPSTREAM_SRC).zip
	mv $(UPSTREAM_SRC) $(DEBIAN_SRC_DIR)
	rm $(DEBIAN_SRC_DIR)/doc/manual.pdf # will be rebuild from latex
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)
	rm -rf $(DEBIAN_SRC_DIR)
	rm $(UPSTREAM_SRC).zip

## flann 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,11 @@
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 
 include(${PROJECT_SOURCE_DIR}/cmake/flann_utils.cmake)
-set(FLANN_VERSION 1.6.11)
+set(FLANN_VERSION 1.7.0)
 DISSECT_VERSION()
 GET_OS_INFO()
+
+list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
 
 # Add an "uninstall" target
 CONFIGURE_FILE ("${PROJECT_SOURCE_DIR}/cmake/uninstall_target.cmake.in"
@@ -40,8 +42,10 @@
 option(BUILD_C_BINDINGS "Build C bindings" ON)
 option(BUILD_PYTHON_BINDINGS "Build Python bindings" ON)
 option(BUILD_MATLAB_BINDINGS "Build Matlab bindings" ON)
+option(BUILD_CUDA_LIB "Build CUDA library" ON)
 option(USE_MPI "Use MPI" OFF)
 
+set(NVCC_COMPILER_BINDIR "" CACHE PATH  "Directory where nvcc should look for C++ compiler. This is passed to nvcc through the --compiler-bindir option.")
 
 if (NOT BUILD_C_BINDINGS)
     set(BUILD_PYTHON_BINDINGS OFF)
@@ -75,17 +79,51 @@
 if (USE_MPI)
     if (NOT MPI_FOUND)
         message(WARNING "Could not find an MPI library. Define the MPI_COMPILER variable to the path of your MPI compiler.")
+        set(USE_MPI OFF)
     endif()
 
     if (NOT HDF5_IS_PARALLEL)
         message(WARNING "For MPI support the Parallel HDF5 library is required.")
+        set(USE_MPI OFF)
     endif()
+endif(USE_MPI)
 
-endif(USE_MPI)
+
 
 find_package(GTest) 
 if (NOT GTEST_FOUND)
 	message(WARNING "gtest library not found, some tests will not be run")
+endif()
+
+find_package(CUDA)
+if(NOT CUDA_FOUND)
+	message(STATUS "CUDA not found, CUDA library will not be built")
+	set(BUILD_CUDA_LIB OFF)
+else(NOT CUDA_FOUND)
+    message(STATUS "CUDA found (include: ${CUDA_INCLUDE_DIRS}, lib: ${CUDA_LIBRARIES})")
+    include_directories(${CUDA_INCLUDE_DIRS})
+endif(NOT CUDA_FOUND)
+
+# find Intel TBB
+find_package(TBB)
+if(TBB_FOUND AND TBB_DEBUG_FOUND)
+    message(STATUS "Intel TBB include dir: " ${TBB_INCLUDE_DIRS})
+    message(STATUS "Intel TBB libs: " ${TBB_LIBRARIES})
+    message(STATUS "Intel TBB libs (debug): " ${TBB_DEBUG_LIBRARIES})
+	include_directories(${TBB_INCLUDE_DIRS})
+endif(TBB_FOUND AND TBB_DEBUG_FOUND)
+
+# print additional info
+if(TBB_FOUND AND NOT TBB_DEBUG_FOUND)
+    message(STATUS "Only the Intel TBB (release) libraries were found")
+endif()
+
+if(TBB_DEBUG_FOUND AND NOT TBB_FOUND)
+    message(STATUS "Only the Intel TBB (debug) libraries were found")
+endif()
+
+if(NOT TBB_FOUND AND NOT TBB_DEBUG_FOUND)
+    message(STATUS "No intel TBB libraries were found")
 endif()
 
 
@@ -97,8 +135,8 @@
 # HDF5 uses long long which is not ansi
 if (WIN32)
     # lots of warnings with cl.exe right now
-    # TODO: fix this
-    add_definitions( "-w" )
+    #add_definitions( "/W1" )
+	add_definitions("-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS")
 else(WIN32)
     add_definitions( "-Wall" )
 endif(WIN32)
@@ -152,4 +190,5 @@
 message(STATUS "Building C bindings: ${BUILD_C_BINDINGS}")
 message(STATUS "Building python bindings: ${BUILD_PYTHON_BINDINGS}")
 message(STATUS "Building matlab bindings: ${BUILD_MATLAB_BINDINGS}")
+message(STATUS "Building CUDA library: ${BUILD_CUDA_LIB}")
 message(STATUS "Using MPI support: ${USE_MPI}")

=== doc/CMakeLists.txt ===
find_package(LATEX)
 
if (EXISTS ${PDFLATEX_COMPILER} AND EXISTS ${BIBTEX_COMPILER})
    include(${PROJECT_SOURCE_DIR}/cmake/UseLATEX.cmake)

    add_latex_document(manual.tex BIBFILES references.bib IMAGE_DIRS images DEFAULT_PDF)

    add_custom_target(doc)
    add_dependencies(doc pdf)
    
    add_custom_command( TARGET doc
        POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy
        ARGS ${CMAKE_CURRENT_BINARY_DIR}/manual.pdf ${CMAKE_CURRENT_SOURCE_DIR}/manual.pdf
    )
endif()

install(
    FILES manual.pdf
    DESTINATION share/doc/flann
)

=== src/matlab/CMakeLists.txt ===
--- 
+++ 
@@ -47,7 +47,8 @@
             DESTINATION share/flann/matlab
         )
     else()
-        message(SEND_ERROR "The 'mex' and 'mexext' programs have been found in different locations. It's likely that one of them is not part of the MATLAB instalation. Make sure that the 'bin' directory from the MATLAB instalation is in PATH")
+        message(WARNING "The 'mex' and 'mexext' programs have been found in different locations. It's likely that one of them is not part of the MATLAB instalation. Make sure that the 'bin' directory from the MATLAB instalation is in PATH")
+        set(BUILD_MATLAB_BINDINGS OFF) 
     endif()
 elseif(OCT_CMD)
   SET(MEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/${MEX_NAME}.mex)
@@ -68,6 +69,7 @@
     DESTINATION share/flann/octave
     )
 else()
-    message(SEND_ERROR "Cannot find MATLAB or Octave instalation. Make sure that the 'bin' directory from the MATLAB instalation or that mkoctfile is in PATH")
+    message(WARNING "Cannot find MATLAB or Octave instalation. Make sure that the 'bin' directory from the MATLAB instalation or that mkoctfile is in PATH")
+    set(BUILD_MATLAB_BINDINGS OFF) 
 endif()

=== debian/changelog ===
flann (1.7.0-1) unstable; urgency=low

  * New upstream. Fix MPI binding
  * Fix doc installation
  * Install upstream changelog

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Tue, 20 Dec 2011 17:13:24 +0100

flann (1.6.11-2) unstable; urgency=low

  * Remove hardcoded version number for boost librairies

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Thu, 25 Aug 2011 14:05:36 +0200

=== debian/control ===
--- 
+++ 
@@ -5,13 +5,13 @@
 DM-Upload-Allowed: yes
 Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>,
  Michael Kleiber <mike@kleibi.de>
-Build-Depends: debhelper (>= 7.0.50~), cmake, quilt (>= 0.46-7~),
- libgtest-dev, python, python-numpy, texlive-binaries, libboost1.46-dev,
+Build-Depends: debhelper (>= 8), cmake, libtbb-dev,
+ libgtest-dev, python, python-numpy, texlive-binaries, libboost-all-dev,
  texlive-latex-base, latex2html, mpi-default-dev, libhdf5-mpi-dev [!hurd-i386]
 Standards-Version: 3.9.2
 Homepage: http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN
-Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/flann/trunk/?rev=0&sc=0
-Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/flann/trunk/
+Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/flann/trunk/
+Vcs-Svn: svn://svn.debian.org/debian-science/packages/flann/trunk/
 
 Package: libflann-dev
 Section: libdevel
@@ -39,7 +39,7 @@
 Package: flann-doc
 Architecture: all
 Section: doc
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, doc-base
 Description: Fast Library for Approximate Nearest Neighbors - documentation
  FLANN is a library for performing fast approximate nearest neighbor searches
  in high dimensional spaces. It contains a collection of algorithms we found

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DBUILD_MATLAB_BINDINGS:BOOL=OFF \
	-DBUILD_PYTHON_BINDINGS:BOOL=OFF \
	-DUSE_MPI:BOOL=ON \
	-DBUILD_CUDA_LIB:BOOL=OFF

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test:
	# test download material from the net. Removing them.

override_dh_compress:
	dh_compress --exclude=.pdf

VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)

UPSTREAM_SRC = flann-$(VER_FULL)-src
DEBIAN_SRC_DIR = flann-$(VER_FULL)
DEBIAN_SRC_TAR = flann_$(VER_FULL).orig.tar.gz

$(UPSTREAM_SRC).zip:
	#uscan --verbose --force-download --repack --rename
	wget -c http://people.cs.ubc.ca/~mariusm/uploads/FLANN/$@

get-orig-source: $(UPSTREAM_SRC).zip
	rm -rf $(DEBIAN_SRC_DIR)
	unzip -q $(UPSTREAM_SRC).zip
	mv $(UPSTREAM_SRC) $(DEBIAN_SRC_DIR)
	rm $(DEBIAN_SRC_DIR)/doc/manual.pdf # will be rebuild from latex
	# download changelog:
	links -dump http://people.cs.ubc.ca/~mariusm/index.php/FLANN/Changelog | tail -n +10 | grep -v PmWiki > $(DEBIAN_SRC_DIR)/Changelog
	GZIP="--best --no-name" tar czf $(DEBIAN_SRC_TAR) $(DEBIAN_SRC_DIR)
	rm -rf $(DEBIAN_SRC_DIR)
	rm $(UPSTREAM_SRC).zip

## flann 1.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)
 
 include(${PROJECT_SOURCE_DIR}/cmake/flann_utils.cmake)
-set(FLANN_VERSION 1.7.0)
+set(FLANN_VERSION 1.7.1)
 DISSECT_VERSION()
 GET_OS_INFO()

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,12 @@
 
 
     if (USE_MPI AND HDF5_IS_PARALLEL)
+        find_package(Boost COMPONENTS mpi system serialization thread REQUIRED)
+        include_directories(${Boost_INCLUDE_DIRS})
+        add_definitions("-DHAVE_MPI")
+
         add_executable(flann_example_mpi flann_example_mpi.cpp)
-        target_link_libraries(flann_example_mpi flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES})
+        target_link_libraries(flann_example_mpi flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})
 
         add_dependencies(examples flann_example_mpi)
         install (TARGETS flann_example_mpi DESTINATION bin)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -19,12 +19,31 @@
 endif()
 
 if (GTEST_FOUND AND HDF5_FOUND)
-    include_directories(${HDF5_INCLUDE_DIR})
+	include_directories(${HDF5_INCLUDE_DIR})
 	flann_add_gtest(flann_simple_test flann_simple_test.cpp)
+    if(TBB_FOUND)
+        add_definitions(-DTBB)
+        flann_add_gtest(flann_multithreaded_test flann_multithreaded_test.cpp)
+        target_link_libraries(flann_multithreaded_test ${TBB_LIBRARIES})
+        target_link_libraries(flann_simple_test ${TBB_LIBRARIES})
+    endif()
 	    target_link_libraries(flann_simple_test flann_cpp ${HDF5_LIBRARIES})
+        if(TBB_FOUND)
+            target_link_libraries(flann_multithreaded_test flann_cpp ${HDF5_LIBRARIES})
+        endif()
     if (HDF5_IS_PARALLEL)
 	    target_link_libraries(flann_simple_test ${MPI_LIBRARIES})
+        if(TBB_FOUND)
+            target_link_libraries(flann_multithreaded_test ${MPI_LIBRARIES})
+        endif()
     endif()
+endif()
+
+if (GTEST_FOUND AND HDF5_FOUND AND BUILD_CUDA_LIB)
+	set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;-arch=sm_13;--compiler-bindir=${NVCC_COMPILER_BINDIR}" )
+	flann_add_cuda_gtest(flann_cuda_test flann_cuda_test.cu)
+	target_link_libraries(flann_cuda_test flann_cpp ${HDF5_LIBRARIES} flann_cuda)
+
 endif()
 
 #---------- pyunit tests --------------

=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -2,14 +2,11 @@
 
 add_definitions(-D_FLANN_VERSION=${FLANN_VERSION})
 
-file(GLOB_RECURSE C_SOURCES *.cpp)
-file(GLOB_RECURSE CPP_SOURCES *.cpp)
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/flann/config.h)
 
-file(GLOB_RECURSE C_FLANN flann.cpp)
-file(GLOB_RECURSE CPP_FLANN flann_cpp.cpp)
-
-list(REMOVE_ITEM CPP_SOURCES ${C_FLANN})
-list(REMOVE_ITEM C_SOURCES ${CPP_FLANN})
+file(GLOB_RECURSE C_SOURCES flann.cpp)
+file(GLOB_RECURSE CPP_SOURCES flann_cpp.cpp)
+file(GLOB_RECURSE CU_SOURCES *.cu)
 
 add_library(flann_cpp_s STATIC ${CPP_SOURCES})
 if(CMAKE_COMPILER_IS_GNUCC)
@@ -17,12 +14,32 @@
 endif()
 set_property(TARGET flann_cpp_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
 
+if (BUILD_CUDA_LIB)
+    if(CMAKE_COMPILER_IS_GNUCC)
+		set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-Xcompiler;-fPIC;-arch=sm_13;--compiler-bindir=${NVCC_COMPILER_BINDIR}" )
+    else()
+	    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS};-arch=sm_13" )
+    endif()
+    cuda_add_library(flann_cuda_s STATIC ${CU_SOURCES})
+    set_property(TARGET flann_cuda_s PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
+endif()
+
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux" AND CMAKE_COMPILER_IS_GNUCC)
     add_library(flann_cpp SHARED "")
     set_target_properties(flann_cpp PROPERTIES LINKER_LANGUAGE CXX)
     target_link_libraries(flann_cpp -Wl,-whole-archive flann_cpp_s -Wl,-no-whole-archive)
+
+    if (BUILD_CUDA_LIB)
+	    cuda_add_library(flann_cuda SHARED "")
+        set_target_properties(flann_cuda PROPERTIES LINKER_LANGUAGE CXX)
+        target_link_libraries(flann_cuda -Wl,-whole-archive flann_cuda_s -Wl,-no-whole-archive)
+    # 	target_link_libraries(flann_cuda cudpp_x86_64)
+    endif()
 else()
     add_library(flann_cpp SHARED ${CPP_SOURCES})
+    if (BUILD_CUDA_LIB)
+		cuda_add_library(flann_cuda SHARED ${CPP_SOURCES})
+    endif()
 endif()
 
 set_target_properties(flann_cpp PROPERTIES
@@ -30,6 +47,14 @@
    SOVERSION ${FLANN_SOVERSION}
    DEFINE_SYMBOL FLANN_EXPORTS
 ) 
+
+if (BUILD_CUDA_LIB)
+    set_target_properties(flann_cuda PROPERTIES
+       VERSION ${FLANN_VERSION}
+       SOVERSION ${FLANN_SOVERSION}
+       DEFINE_SYMBOL FLANN_EXPORTS
+    ) 
+endif()
 
 
 #debug libraries
@@ -42,6 +67,39 @@
 add_library(flann_cpp_s-gd STATIC ${CPP_SOURCES})
 set_target_properties(flann_cpp_s-gd PROPERTIES COMPILE_FLAGS ${CMAKE_CXX_FLAGS_DEBUG})
 set_property(TARGET flann_cpp_s-gd PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
+
+
+
+if (HDF5_FOUND)
+    include_directories(${HDF5_INCLUDE_DIR})
+
+    if (USE_MPI AND HDF5_IS_PARALLEL)
+        find_package(Boost COMPONENTS mpi serialization system thread REQUIRED)
+        include_directories(${Boost_INCLUDE_DIRS})
+        add_definitions("-DHAVE_MPI")
+
+        add_executable(flann_mpi_server flann/mpi/flann_mpi_server.cpp)
+        target_link_libraries(flann_mpi_server flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})
+        
+        add_executable(flann_mpi_client flann/mpi/flann_mpi_client.cpp)
+        target_link_libraries(flann_mpi_client flann_cpp ${HDF5_LIBRARIES} ${MPI_LIBRARIES} ${Boost_LIBRARIES})
+   
+        install (TARGETS flann_mpi_client flann_mpi_server
+                DESTINATION bin)
+    endif()
+endif()
+
+if (BUILD_CUDA_LIB)
+    add_library(flann_cuda-gd SHARED ${CPP_SOURCES})
+    set_target_properties(flann_cuda-gd PROPERTIES 
+        COMPILE_FLAGS ${CMAKE_CXX_FLAGS_DEBUG}
+        DEFINE_SYMBOL FLANN_EXPORTS
+    )
+
+    add_library(flann_cuda_s-gd STATIC ${CPP_SOURCES})
+    set_target_properties(flann_cuda_s-gd PROPERTIES COMPILE_FLAGS ${CMAKE_CXX_FLAGS_DEBUG})
+    set_property(TARGET flann_cuda_s-gd PROPERTY COMPILE_DEFINITIONS FLANN_STATIC)
+endif()
 
 if (BUILD_C_BINDINGS)
     add_library(flann_s STATIC ${C_SOURCES})
@@ -82,6 +140,15 @@
     LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
     ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
 )
+ 
+if (BUILD_CUDA_LIB)
+    install (
+        TARGETS flann_cuda flann_cuda_s flann_cuda-gd flann_cuda_s-gd
+        RUNTIME DESTINATION bin
+        LIBRARY DESTINATION ${FLANN_LIB_INSTALL_DIR}
+        ARCHIVE DESTINATION ${FLANN_LIB_INSTALL_DIR}
+    )
+endif()
 
 if (BUILD_C_BINDINGS)
     install (

=== debian/changelog ===
flann (1.7.1-4) unstable; urgency=low

  * enable the libhdf5-mpi-dev build dependency on hurd. Closes: #673513
  * Fix hardening switch to compat 9

 -- Mathieu Malaterre <malat@debian.org>  Sun, 03 Jun 2012 18:55:10 +0200

flann (1.7.1-3) unstable; urgency=medium

  * Add Breaks/Replaces for libflann1. Closes: #672443

 -- Mathieu Malaterre <malat@debian.org>  Mon, 14 May 2012 12:47:24 +0200

flann (1.7.1-2) unstable; urgency=low

  * Use my @d.o alias
  * Bump to Std-Vers to 3.9.3, no changes needed
  * Switch to default boost instead of old 1.48 (boost transition)
  * Use proper SONAME in package naming

 -- Mathieu Malaterre <malat@debian.org>  Mon, 07 May 2012 11:17:04 +0200

flann (1.7.1-1) unstable; urgency=low

  * New upstream
  - Fix clashes with other libraries
  * Remove doc install patch (applied upstream)

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 28 Dec 2011 16:44:49 +0100

flann (1.7.0-4) unstable; urgency=low

  * Rebuild flann using boost 1.48.
  * Set minimum cmake version.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Mon, 26 Dec 2011 14:27:11 +0100

flann (1.7.0-3) unstable; urgency=low

  * Remove cmake install rule for manual.pdf.

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 21 Dec 2011 19:46:50 +0100

flann (1.7.0-2) unstable; urgency=low

  * Remove TBB for non-intel arch
  * Move indep dependencies to B-D-I
  * Build doc in indep target

 -- Mathieu Malaterre <mathieu.malaterre@gmail.com>  Wed, 21 Dec 2011 18:14:28 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Priority: optional
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 DM-Upload-Allowed: yes
-Uploaders: Mathieu Malaterre <mathieu.malaterre@gmail.com>,
+Uploaders: Mathieu Malaterre <malat@debian.org>,
  Michael Kleiber <mike@kleibi.de>
-Build-Depends: debhelper (>= 8), cmake, libtbb-dev,
- libgtest-dev, python, python-numpy, texlive-binaries, libboost-all-dev,
- texlive-latex-base, latex2html, mpi-default-dev, libhdf5-mpi-dev [!hurd-i386]
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), cmake (>= 2.6.0), libtbb-dev [amd64 i386 ia64],
+ libgtest-dev, python, python-numpy, libboost-all-dev,
+ mpi-default-dev, libhdf5-mpi-dev
+Build-Depends-Indep: texlive-latex-base, texlive-binaries, latex2html
+Standards-Version: 3.9.3
 Homepage: http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN
 Vcs-Browser: http://anonscm.debian.org/viewvc/debian-science/packages/flann/trunk/
 Vcs-Svn: svn://svn.debian.org/debian-science/packages/flann/trunk/
@@ -16,7 +17,7 @@
 Package: libflann-dev
 Section: libdevel
 Architecture: any
-Depends: libflann1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libflann1.7 (= ${binary:Version}), ${misc:Depends}
 Description: Fast Library for Approximate Nearest Neighbors - development
  FLANN is a library for performing fast approximate nearest neighbor searches
  in high dimensional spaces. It contains a collection of algorithms we found
@@ -25,9 +26,11 @@
  .
  This package contains development files needed to build FLANN applications.
 
-Package: libflann1
+Package: libflann1.7
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Replaces: libflann1 (<< 1.7.1-2)
+Breaks: libflann1 (<< 1.7.1-2)
 Description: Fast Library for Approximate Nearest Neighbors - runtime
  FLANN is a library for performing fast approximate nearest neighbor searches
  in high dimensional spaces. It contains a collection of algorithms we found

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,12 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
 
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 DPKG_EXPORT_BUILDFLAGS = 1
 -include /usr/share/dpkg/buildflags.mk
 
 CMAKE_FLAGS = \
 	-DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
-	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DBUILD_MATLAB_BINDINGS:BOOL=OFF \
 	-DBUILD_PYTHON_BINDINGS:BOOL=OFF \
 	-DUSE_MPI:BOOL=ON \
@@ -23,6 +23,13 @@
 
 override_dh_compress:
 	dh_compress --exclude=.pdf
+
+# Let's be smart with building doc
+override_dh_auto_build-indep:
+	$(MAKE) -C obj-* doc
+
+# No tests needed for docs
+override_dh_auto_test-indep:
 
 VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)

=== debian/watch ===
version=3
http://www.cs.ubc.ca/~mariusm/index.php/FLANN/FLANN .*flann-(.*)-src.zip \
debian debian/orig-tar.sh
